local materials = require("material")
local TurnHelper = require("time.turnhelper")
local Block = require("blocks.Block")
local blockBuilding = require("blocks.blockBuilding")


local Bamboo = Block:new()
Bamboo.transparent = true
Bamboo.className = "Bamboo";
--Bamboo.__index = Bamboo
Bamboo.maxDurability = 100
Bamboo.mass = 0.5
Bamboo.maxPlantHeight = 5
function Bamboo:new()  
  self.__index = self
  local instance = Block.new(Bamboo)
  if self.maxDurability ~= 100 then error("wtf durability") end      
  setmetatable(instance,self)  
  blockBuilding.makeTicking(instance,1000)
    
  return instance
end

function Bamboo:tick()
  

  local level = self.level; if not level then return end;
  local x = self.position.x  
  local y = self.position.y
  
  local function hasSameBlocksBelow(n)
    local good = true
    for i = 1,n do
      local same = self.__index.blockId == level:getBlock(x, y+i).__index.blockId
      if not same then
        good = false
        break
      end
    end
    return good
  end
  
  if level:getBlock(x,y-1).blockId == "core:sky" and not hasSameBlocksBelow(self.maxPlantHeight-1) then
    --print("above me is the sky!")
    self.turnHelper.interval = 5000
    dispatcher:runOnce("enterFrame", function() level:setBlock(x, y-1, Bamboo:new()) end)
  end
end




return Bamboo
