local TurnHelper = require("time.turnhelper")
local M = {}

function M.makeTicking(instance, interval)    
  if not interval then
    interval = 1000
  end
  
  -- init ticking
  local function maketicker(instance)
    local _instance = instance
    local ticker = function(event,data) _instance:tick(data) end
    return ticker
  end
  instance.ticker = maketicker(instance)    
  instance.turnHelper = TurnHelper:new(interval, instance.ticker)
  
  -- deactivate when not on level
  local originalSetLevel = instance.setLevel
  function instance:setLevel(level)
    self.turnHelper:setActive(level~=nil)
    originalSetLevel(self, level)
  end
  
end

return M