local Entity = require("entities.Entity")
assert(Entity)
local BlockEntity = Entity:new()

BlockEntity.isBlockEntity = true
function BlockEntity:new(block)
  self.__index = self    
  
  local instance = Entity:new()  
  setmetatable(instance,self)
  instance.className = "BlockEntity"
  instance.position = block.position * BLOCK_SIZE  
  instance.shapeWidth = BLOCK_SIZE/2
  instance.shapeHeight = BLOCK_SIZE/2
  if block.entitySpeed then
    instance.speed = block.entitySpeed
  end
  block.entity = instance
  instance.block = block
  instance.material = block.material
  instance.durability = block.__index:new().durability
  instance.mass = block.__index:new().mass

  
  return instance
end

function BlockEntity:equals(other)
  if getmetatable(other) == getmetatable(self) then
    if self.block.blockId == other.block.blockId then
      return true
    end
  end
  return false
end


return BlockEntity