local points = require("point")
local Point = points.Point
local materials = require("material")

local Entity = {className="object"}

function Entity:new()  
  local instance = {}
  instance.className="Entity"
  instance.position = points.new()
  instance.material = materials.all["flying_medusa"]  
  instance.mass = 1
  instance.shapeWidth = 48
  instance.shapeHeight = 96
  instance.shape = points.createPointCollection({0,0, instance.shapeWidth,0, instance.shapeWidth,instance.shapeHeight, 0, instance.shapeHeight})
  instance.durability = 10000
  
  
  instance.speed = points.new()  
  instance.maxSpeed = 1500
  instance.acceleration = points.new()
  instance.maxAcceleration = 150
  
  instance.forces = {}
  instance.playerControlled = false
  
  
  self.__index = self
  return setmetatable(instance, self)
end

function Entity:addForce(force)
  table.insert(self.forces, force)
end

function Entity:applyForces()
  local sumForce = points.new()
  for i, force in ipairs(self.forces) do
    sumForce = sumForce + force
  end
  
  if self.mass > 0.00001 then
    self.acceleration = sumForce * (1.0 / self.mass) 
  end
  
  self.forces = {}  
  
end

function Entity:getSize()
  return points.new(self.shapeWidth,self.shapeHeight)
end

function Entity:equals(other)
  return self == other
end


return Entity