local classUtils = require("utils.classutils")
local Inventory = require("entities.inventory.Inventory")
local M = {}
function M.makeWithEquipment(entity)
  print("CLASS NAME="..entity.className)
  entity.equipment = {}
  function entity:equip(thing)
    self.equipment[thing] = true
  end
  function entity:unequip(thing)
    self.equipment[thing] = nil
  end
  
  
  
  local originalSetPosition = entity.setPosition
  function entity:setPosition(pt)
    --print("setPosition equipments")
    if originalSetPosition then
      originalSetPosition(self, pt)
    else
      self.position:set(pt)
    end
    for k,v in pairs(self.equipment) do
      k.position=self.position
    end
  end
  classUtils.makeProperty(entity, "position")
  
end

function M.makeWithInventory(entity)
  entity.inventory = Inventory:new()
end


return M