local Slot = {}
local trueFunction = function() return true end


function  Slot:new(name, filterFunction)
  if not name then 
    name = "Slot"
  end
  if not filterFunction then
    filterFunction = trueFunction
  end
  
  self.__index = self
  local instance = {
    name=name,    
    filterFunction = filterFunction,
    index=-1,
  }
  
  setmetatable(instance, self)
  return instance
end

function Slot:setStack(stack)
  if self.filterFunction(stack) then
    self.stack = stack
    return true
  end
  return false
end

function Slot:getStack(stack)
  return self.stack
end



return Slot