local Group = require("graphics.ui.controls.Group")
local InventoryControl = require("graphics.ui.controls.InventoryControl")
local Hud = Group:new()


function Hud:setEntity(entity)
  self.entity = entity
  if entity.inventory then
    local child = InventoryControl:new()
    child:setInventory(entity.inventory)
    child.size.x = love.graphics:getWidth()
    child.size.y = love.graphics:getHeight()
    child.bottom = 30    
    child.horizontalCenter = 0
    self:addChild(child)
    self.inventoryControl = child
    self.inventoryControl.visible = false
  end
  
end

function Hud:keypressed(key, scancode,isrepeat)
  --print(tostring(key).." "..tostring(self.inventoryControl))
  if key=="i" and self.inventoryControl then
    self.inventoryControl.visible = not self.inventoryControl.visible
  end
end

return Hud