local points = require("point")
local Control = {}
function Control:new()
  self.__index = self
  local instance = {
    position = points.new(),
    size = points.new(64,64),
    measuredSize = points.new(64,64),
    visible=true,
    includeInLayout=true
  }
  setmetatable(instance, self)
  return instance
end

function Control:draw()
  if not self.visible then
    return
  end
  love.graphics.push()
  love.graphics.translate(self.position.x, self.position.y)
  self:drawInside()
  love.graphics.pop()
end

function Control:drawInside()
  love.graphics.setColor(66, 255, 66, 96)
  love.graphics.rectangle("fill", 0, 0, self.size.x, self.size.y)
end


return Control
