local Control = require("graphics.ui.Control")
local BasicLayot = require("graphics.ui.layouts.BasicLayout")
local Group = Control:new()
function Group:new()
  self.__index = self
  local instance = Control.new(Group)
  setmetatable(instance, self)
  
  instance.children = {}
  instance.numChildren = 0
  instance.layout = BasicLayot:new(instance)
  
  return instance
end

function Group:addChild(control)
  table.insert(self.children, control)
  self.numChildren = self.numChildren + 1
end

function Group:removeChild(control)  
  local children = self.children
  for i = #children, 1 do
    if children[i] == control then
      table.remove(children, i)
      self.numChildren = self.numChildren - 1
    end
  end  
end

function Group:getChildAt(i)
  if i < 1 or i > self.numChildren then
    error("no such child"..tostring(i))
  end
  return self.children[i]
end

function Group:drawInside()
  self.layout:layout(self)
  for i,child in ipairs(self.children) do
    child:draw()
  end
end




return Group