local Group = require("graphics.ui.controls.Group")
local SlotControl = require("graphics.ui.controls.SlotControl")
local TileLayout = require("graphics.ui.layouts.TileLayout")
local InventoryControl = Group:new()

function InventoryControl:setInventory(inventory)  
  if self.inventory then error("don't set inventory twice") end
  self.layout = TileLayout:new(self)
  self.layout.rowSize = 9
  self.inventory = inventory
  for i = 1, inventory.size do
    local child = SlotControl:new()
    child:setSlot(inventory:getSlotAt(i))
    self:addChild(child)
  end
end

return InventoryControl