local Control = require("graphics.ui.Control")
local debugUtil = require("debug.debugUtil")
local SlotControl = Control:new()
function SlotControl:new()
  self.__index = self
  local instance = Control.new(SlotControl)
  setmetatable(instance, self)
  return instance
end

function SlotControl:setSlot(slot)
  self.slot = slot
end

function SlotControl:drawInside()
  local slot = self.slot
  
  love.graphics.setBlendMode("screen")    
  love.graphics.setColor(230, 255, 230,128)
  love.graphics.rectangle("fill",0,0,self.size.x, self.size.y)
  
  
  love.graphics.setBlendMode("alpha")    
  love.graphics.setColor(66, 189, 139,255)
    
  love.graphics.rectangle("line",0,0,self.size.x, self.size.y)
  

  local stack = slot:getStack()
  
  love.graphics.setColor(255,255,255,255)
  if stack then
    local image = textures[stack.entity.material.textureId]
    local scale = math.min(64/image:getWidth(), 64/image:getHeight())
    love.graphics.draw(image, 0,0,0, scale,scale)
    --love.graphics.setBlendMode("screen")    
    --love.graphics.setColor(0,0,0,255)
    --love.graphics.printf(tostring(stack.count),48,48,1000, "right")
    local countString = tostring(stack.count)
    local shift = 8 * countString:len()
    love.graphics.print(tostring(stack.count),self.size.x - shift,self.size.y-16)
  
  end
    
end
  

return SlotControl