local BasicLayout = {}
function BasicLayout:new(target)
  self.__index = self
  local instance = {target=target}
  setmetatable(instance,self)
  return instance
end

function BasicLayout:layout()  
  local target = self.target
  if target.numChildren == 0 then
    return
  end
  
  
  
  local w = target.size.x
  local h = target.size.y
  
  
  for i=1,target.numChildren do  
    local c = target:getChildAt(i)
    if c.includeInLayout then
      if c.horizontalCenter then
        c.position.x = math.floor((w - c.size.x)/2 + c.horizontalCenter)
      end
      if c.verticalCenter then
        c.position.y = math.floor((h - c.size.y)/2+c.verticalCenter)
      end
      if c.right then
        c.position.x = w - c.size.x - c.right
      end
      if c.bottom then
        c.position.y =  h - c.size.y - c.bottom
      end    
    end
  end
    
end



return BasicLayout