local TileLayout = {}
function TileLayout:new(target)
  self.__index = self
  local instance = {target=target}
  setmetatable(instance,self)
  return instance
end

function TileLayout:layout()  
  
  local target = self.target
  if target.numChildren == 0 then
    return
  end
  
  local child = target:getChildAt(1)
  local tileWidth = child.size.x
  local tileHeight = child.size.y
  local w = target.size.x
  
  local rowSize = self.rowSize or math.max(1,math.floor(w / tileWidth))
  for i=1,target.numChildren do
    local c = target:getChildAt(i)
    if c.includeInLayout then
      local ii = i - 1
      
      local xI = fmod(ii, rowSize)
      local yI = math.floor(ii/rowSize)
      c.position.x = xI * tileWidth
      c.position.y = yI * tileHeight    
     -- print("position is "..tostring(c.position))
    
      if self.rowSize then
        target.size.x = self.rowSize * tileWidth
        target.size.y = math.ceil(target.numChildren/rowSize)*tileHeight
      end
    end   
  end
end



return TileLayout