local blocks = require("blocks.blocks")
local mods = require("mod")
local fileutils = require("utils.fileutils")

local M = {}
local ModLoader  = {}

M.ModLoader = ModLoader
M.all = {}
function ModLoader:new()
  self.__index = self
  local instance = {}
  return setmetatable(instance,self)  
end

function ModLoader:load()
  local path = fileutils.getModsRoot()
  fileutils.forChildPaths(path, function(dirName)
    local name = fileutils.extract(dirName)
    print("loading mod: "..name)
    M.all[name] = self:loadMod(dirName, name)
  end)
end

function ModLoader:loadMod(dirName, modName)
  local result = mods.Mod:new()
  local blocksParent = dirName.."/".."blocks"
  print("blocks dir "..blocksParent)
  fileutils.forChildPaths(blocksParent,
    function(blockPath)    
      blocks.loadBlockClass(blockPath, modName)
    end)
end

return M