local points = require("point")
local EntityMovement = {}
function EntityMovement:new(topLeft, bottomRight)
  self.__index = self
  local instance = {
    topLeft = topLeft,
    bottomRight = bottomRight
  }
  return setmetatable(instance,self)
end

function EntityMovement:handle(entity, dt)  
  local lastStep
  if not entity.lastStep then
    lastStep = {
      position=points.new(),
      speed = points.new(),
      acceleration = points.new()      
    }
    entity.lastStep = lastStep
  else
    lastStep = entity.lastStep
  end
  
  
  entity.lastStep.position:set(entity.position)
  entity.lastStep.speed:set(entity.speed) --:clone():cappedLength(entity.maxSpeed)
  entity.lastStep.acceleration:set(entity.acceleration) -- = entity.acceleration:clone():cappedLength(entity.maxAcceleration)
  
  
  local acceleration = entity.acceleration--:cappedLength(entity.maxAcceleration)
  
  local startSpeed = entity.speed:clone()--:cappedLength(entity.maxSpeed)
  local endSpeed = (startSpeed + acceleration * dt)--:cappedLength(entity.maxSpeed)
  
  local avgSpeed = (startSpeed + endSpeed) * 0.5
        
  local position = entity.position + avgSpeed * dt
  --position = position:modInsideRect(self.topLeft, self.bottomRight)
      
  entity.position=position
  entity.speed:set(endSpeed)
  entity.acceleration:set(acceleration)
  
  
end


return EntityMovement