local points = require("point")
local SurfaceGravity = {}
function SurfaceGravity:new(gravity_constant)
  if not gravity_constant then
    gravity_constant = 9.81
  end
  self.__index = self
  local instance = {
    g = gravity_constant
  }
  return setmetatable(instance, self)
end

function SurfaceGravity:addForce(entity)
  --if not entity.playerControlled then  
    entity:addForce(points.new(0, entity.mass * self.g))
  --end
end

return SurfaceGravity