local args = {...}
local afterLoad = args[1] == true
print("TEST MODE: afterLoad="..tostring(afterLoad))
local fileUtils = require("utils.fileutils")
local testPath = "test"

local function exceptThisFile(path)
  return fileUtils.extract(path)~="test.lua"
end

local runTest

local function runTestsInDir(directoryPath)
  fileUtils.forChildPaths(directoryPath, runTest, exceptThisFile)
end

function runTest(testPath)
  if love.filesystem.isDirectory(testPath) then
    runTestsInDir(testPath)
  else
    local testAfterLoad = testPath:find("afterload")~=nil
    if testAfterLoad~=afterLoad then return end
    love.filesystem.load(testPath)()
    print("test "..testPath.." OK")
  end
end


runTestsInDir(testPath)
