

local ffi = require("ffi")
ffi.cdef[[
   void free(void* memblock);
   void* malloc(size_t memsize);
]]
local thread = love.thread.newThread("threads/rwFileThread.lua")
local threadCallbacks = require("threads.ThreadCallBacks").getInstance()
local channelName = "testRwInputChannel"
local resultChannelName = "rwTestResultChannel"
thread:start(channelName, resultChannelName)
local function checkThread()
  local _error =  thread:getError()
  if _error then error(_error) end
  if not thread:isRunning() then
    error("rw thread not running")
  end
end

checkThread()
love.filesystem.createDirectory(love.filesystem.getSaveDirectory())
local testFileName = love.filesystem.getSaveDirectory() .. "/testfile.txt"
local testFile,data = io.open(testFileName,"w")
assert(testFile, "testFile not opened! "..tostring(testFileName).." because "..tostring(data))
testFile:write("01234567890123456789HelloWorldEndOfFile!")
testFile:close()
local function compareFileTo(expectedData)
  local checkedFile = io.open(testFileName,"r")
  local data = checkedFile:read("*all")
  checkedFile:close()
  assert(data == expectedData)
end



local channel = love.thread.getChannel(channelName)
local results = love.thread.getChannel(resultChannelName)

local fileHandle
local dummyCallbackIndex = -1
local _
channel:push({"open", testFileName, dummyCallbackIndex})
for i=1, 1000000 do local j=i end


_, fileHandle = unpack(results:demand())

checkThread()
assert(fileHandle~=nil, "open failure")


local dataPtr
channel:push({"read", fileHandle, 20, 10, dummyCallbackIndex})
_,dataPtr = unpack(results:demand())
dataPtr = ffi.cast("char*", dataPtr)
local dataString = ffi.string(dataPtr,10)
ffi.C.free(dataPtr)
checkThread()
assert(dataString == "HelloWorld", "read test failed!")

local newEnd = "Mushrooms!"
local dataPtr = ffi.cast("char*", ffi.C.malloc(#newEnd+1))
ffi.copy(dataPtr, newEnd, #newEnd)
dataPtr = tonumber(ffi.cast("intptr_t", dataPtr))
checkThread()


channel:push({"write", fileHandle, 30, dataPtr, #newEnd, dummyCallbackIndex})
checkThread()
results:demand()


channel:push({"close", fileHandle, dummyCallbackIndex})
checkThread()
results:demand()

compareFileTo("01234567890123456789HelloWorldMushrooms!")
