local fileutils = require("utils.fileutils")
local materials = require("material")
local M = {}
function M.loadTexturesInto(path, object)
  object.textures = {}
  object.materials = {}
  
  print("    textures in "..path)

  fileutils.forChildPaths(
    path,
    function(full)
      
      local image = love.graphics.newImage(full)
      local name = fileutils.extractName(full)
      print("    texture: "..name)    
      object.textures[name] = image
      local globalId = fileutils.pathToId(full)
      textures[globalId] = image
      
      object.materials[name] = materials.simple(globalId)      
      
    end,
    "%.png$"
  )
end
return M