
local ffi = require("ffi")
ffi.cdef[[
  void* malloc(size_t size);
]]




local IdTable = require("game.IdTable")
local Generator = require("generation.generators.Generator")




local args = {...}
local idTableData = args[1]
local idTable = IdTable:new()
idTable:fromThreadData(idTableData)

local seed = args[2]
local generator = Generator:new(seed)
generator.groundBlockLayer = args[3]
generator.height = args[4]

local paramsChannelName = "generatorParams"..seed
local inputChannel =  love.thread.getChannel(paramsChannelName)
local outputChannel = love.thread.getChannel("results")




while true do
  local layer,  startX, startY, endX, endY, callBackIndex = unpack(inputChannel:demand())
  local n = (endX - startX + 1) * (endY-startY + 1)
  local result = ffi.cast("double*", ffi.C.malloc(n * ffi.sizeof(ffi.new("double"))))
  local nextIndex = 0
  for y = startY, endY do
    for x = startX, endX do

      result[nextIndex] = idTable:getIndex(generator:getBlockId(x,y, layer))
      nextIndex = nextIndex + 1
    end
  end
  local pointerAsInt = tonumber(ffi.cast("intptr_t",result))
  outputChannel:push({callBackIndex, pointerAsInt})
  io.stdout:flush()
end
