local turnRunner = require("time.turnrunner").default
local TurnHelper= {}

function TurnHelper:new(interval, handler)
  --print("creating helper!")
  if not interval then
    interval = 1000
  end
  self.__index = self
  local instance = {
    interval = interval,
    handler = handler,   
    active = true
  }
  
  setmetatable(instance,self)  
  
  instance.subFunction = function() 
    --print("dooo"); 
    instance:runAndResub(); 
  end
  
  instance:sub()
  return instance
end


function TurnHelper:sub()
  turnRunner:scheduleListenerIn(self.interval, self.subFunction)
end

function TurnHelper:runAndResub() 
  if self.active then
    --print("resubbing!")
    self.handler()  
    self:sub()
  end
end

function TurnHelper:setActive(active)
  if not self.active and active then
    self:sub()
  end
  self.active = active
  --print("SET ACTIVE TO "..tostring(self.active))
end


return TurnHelper