local points = require("point")
local ToolController = {}
function ToolController:new(tool, gameArea)
  self.__index = self
  local instance = { tool = tool, gameArea = gameArea}
  setmetatable(instance,self)
  return instance
end

function ToolController:update(dt)
  local mouse = points.new(love.mouse.getX(), love.mouse.getY())
  local entityPos = points.new(love.graphics.getWidth()/2, love.graphics.getHeight()/2)
  self.tool.shift = mouse - entityPos
  self.tool.dt = dt
  
  if love.mouse.isDown(1) then    
    self.gameArea:applyTool(self.tool)
  end
  
end
return ToolController