local M = {}
function M.copyUpFunction(parent, childName, functionName)
  parent[functionName] = function(self, ...)
    local arg = {...}
    local child = self[childName]
    child[functionName](child, unpack(arg))
  end
end

function M.makeProperty(parent, childName)  
  if not parent.classPropertiesStorage then
    parent.classPropertiesStorage = {}
    parent.classProperties = {}
    
    
    
    local metaTable= getmetatable(parent)
    local originalIndex = metaTable.__index
    
    local newMetaTable = {}
    
    newMetaTable.__index = function(t,k)           
      if k=="classProperties" or k == "classPropertiesStorage" or not t.classProperties[k] then        
        if type(originalIndex)=="function" then
          return originalIndex(t,k)
        elseif type(originalIndex)=="table" then
          return originalIndex[k]
        else
          return rawget(t,k)
        end
      end
      local getterName =  "get"..k:sub(1,1):upper() ..k:sub(2)
      if t[getterName] then
        return t[getterName](t)
      else
        return t.classPropertiesStorage[k]
      end
    end
    local originalNewIndex = metaTable.__newindex
    newMetaTable.__newindex = function(t,k,v)
            
      if k == "__index" or not t.classProperties[k] then      
        if type(originalNewIndex)=="function" then          
          return originalNewIndex(t,k,v)
        elseif type(originalNewIndex)=="table" then
          originalNewIndex[k] = v
        else
          return rawset(t,k,v)
        end
      end
      local setterName = "set"..k:sub(1,1):upper()..k:sub(2)
      if t[setterName] then
        return t[setterName](t,v)
      else
        t.classPropertiesStorage[k] = v
        return v
      end
    end
    setmetatable(parent, newMetaTable)
  end

  
  if not parent.classProperties[childName] then
    parent.classPropertiesStorage[childName] = parent[childName]
    parent[childName] = nil
    parent.classProperties[childName] = true
  end
  return parent  
end

return M